package nianioTest.complib.controls;

import genrap.ui.compLib.base.Action;
import genrap.ui.compLib.types.Shortcut;
import genrap.ui.framework.CompHandle;
import genrap.ui.framework.types.ImageOption;
import nianio.complib.controls.ButtonCommand;
import nianio.complib.controls.ButtonEvent;
import ocean.common.Err;
import ocean.common.Proc;
import ocean.models.SimpleModel;

public class Button {
	private final CompHandle button;
	private final SimpleModel/*String*/text;
	private final SimpleModel/*Boolean*/enabled;
	private final ButtonEvent.MMIntf invoker;

	private Button(String text, boolean enabled, ButtonEvent.MMIntf invoker) {
		this.text = new SimpleModel(text);
		this.enabled = new SimpleModel(new Boolean(enabled));
		this.invoker = invoker;
		Action buttonAction = new Action(new ButtonProc(),
				ImageOption.createNone(), Shortcut.createNone(),
				this.text.getModel(), this.enabled.getModel(), null);
		this.button = genrap.ui.compLib.j2se.comps.Button.create(buttonAction,
				new Proc() {
					public void run() {
					}
				});
	}

	private class ButtonProc implements Proc {
		public void run() {
			invoker.fired();
		}
	}

	public static Button create(String text, boolean enabled,
			ButtonEvent.MM invoker) {
		return new Button(text, enabled, ButtonEvent.MMConv.asIntf(invoker));
	}

	public void post(ButtonCommand cmd) {
		if (cmd.isEnable()) {
			Boolean newValue = new Boolean(true);
			if (!newValue.equals(enabled.get()))
				enabled.set(newValue);
		} else if (cmd.isDisable()) {
			Boolean newValue = new Boolean(false);
			if (!newValue.equals(enabled.get()))
				enabled.set(newValue);
		} else
			throw Err.errM(cmd);
	}

	public CompHandle getHandle() {
		return button;
	}
}
