package nianioTest.complib.repository;

import genrap.ui.framework.CompHandle;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.controls.ButtonEvent;
import nianio.complib.controls.ButtonState;
import nianio.complib.controls.ControlIdEvent;
import nianio.ids.ButtonId;
import nianioTest.complib.controls.Button;

public class ButtonRepository {
	private final CompsMap compsMap = new CompsMap();
	private final ControlIdEvent.MMIntf deliverer;

	public ButtonRepository(ControlIdEvent.MMIntf deliverer) {
		this.deliverer = deliverer;
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(ButtonId id, Button comp) {
			this.compsMap.put(id, comp);
		}

		public Button get(ButtonId id) {
			return (Button) this.compsMap.get(id);
		}
	}

	private class MyDeliverer implements ButtonEvent.MM {
		final private ButtonId id;

		public MyDeliverer(ButtonId id) {
			this.id = id;
		}

		public void invoke(ButtonEvent cmd) {
			deliverer.buttonEvent(id, cmd);
		}
	}

	public CompHandle addButton(ButtonState state) {
		ButtonId id = state.getId();
		Button button = Button.create(state.getText(), state.getEnabled(),
				new MyDeliverer(id));
		compsMap.put(id, button);
		return button.getHandle();
	}

	public Button get(ButtonId id) {
		return compsMap.get(id);
	}

}
