package nianioTest.complib.repository;

import genrap.ui.framework.CompHandle;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.controls.LabelState;
import nianio.ids.LabelId;
import nianioTest.complib.controls.Label;

public class LabelRepository {
	private final CompsMap compsMap = new CompsMap();

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(LabelId id, Label comp) {
			this.compsMap.put(id, comp);
		}

		public Label get(LabelId id) {
			return (Label) this.compsMap.get(id);
		}
	}

	public CompHandle addLabel(LabelState state) {
		LabelId id = state.getId();
		Label label = Label.create(state.getText());
		compsMap.put(id, label);
		return label.getHandle();
	}

	public Label get(LabelId id) {
		return compsMap.get(id);
	}
}
