package nianioTest.complib.repository;

import genrap.ui.appLogic.layouts.UniLayout;
import genrap.ui.framework.Layout;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.UniLayoutParams;
import nianio.ids.PanelId;
import nianioTest.complib.controls.Panel;
import ocean.common.Err;

public class PanelRepository {
	private final CompsMap compsMap = new CompsMap();

	public PanelRepository() {
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(PanelId id, Panel comp) {
			this.compsMap.put(id, comp);
		}

		public Panel get(PanelId id) {
			return (Panel) this.compsMap.get(id);
		}
	}

	public Panel addPanel(PanelId id, nianio.complib.Layout l) {
		Layout layout = createLayout(l);
		Panel panel = Panel.create(layout);
		compsMap.put(id, panel);
		return panel;
	}

	private Layout createLayout(nianio.complib.Layout layout) {
		if (layout.isUniLayout()) {
			UniLayoutParams params = layout.asUniLayout();
			UniLayout uniLayout = new UniLayout(params.getCols(),
					params.getRows(), params.getHGap(), params.getVGap());
			return uniLayout;
		} else
			throw Err.errM(layout);
	}

}
