package nianioTest.complib.repository;

import genrap.ui.compLib.base.CompsFactory;
import genrap.ui.framework.CompHandle;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.controls.ControlIdEvent;
import nianio.complib.controls.RadioButtonGroupEvent;
import nianio.complib.controls.RadioButtonGroupState;
import nianio.ids.RadioButtonGroupId;
import nianioTest.complib.controls.RadioButtonGroup;

public class RadioButtonGroupRepository {
	private final CompsMap compsMap = new CompsMap();
	private final ControlIdEvent.MMIntf deliverer;
	private final CompsFactory cFactory;

	public RadioButtonGroupRepository(ControlIdEvent.MMIntf deliverer,
			CompsFactory cFact) {
		this.cFactory = cFact;
		this.deliverer = deliverer;
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(RadioButtonGroupId id, RadioButtonGroup comp) {
			this.compsMap.put(id, comp);
		}

		public RadioButtonGroup get(RadioButtonGroupId id) {
			return (RadioButtonGroup) this.compsMap.get(id);
		}
	}

	private class MyDeliverer implements RadioButtonGroupEvent.MM {
		final private RadioButtonGroupId id;

		public MyDeliverer(RadioButtonGroupId id) {
			this.id = id;
		}

		public void invoke(RadioButtonGroupEvent cmd) {
			deliverer.radioButtonGroupIdEvent(id, cmd);
		}
	}

	public CompHandle addRadioButtonGroup(RadioButtonGroupState state) {
		RadioButtonGroupId id = state.getId();
		RadioButtonGroup radioButtonGroup = RadioButtonGroup.create(
				state.getLabel(), state.getButtons(), state.getSelectedId(),
				new MyDeliverer(id), cFactory);
		compsMap.put(id, radioButtonGroup);
		return radioButtonGroup.getHandle();
	}

	public RadioButtonGroup get(RadioButtonGroupId id) {
		return compsMap.get(id);
	}

}
