package nianioTest.nianio.impl;

import nianio.SelectFileState;
import nianio.SelectFileExtCmd.MMIntf;
import nianio.complib.filechooser.Extensions;
import nianio.complib.filechooser.FileChooserKind;
import nianio.complib.filechooser.FileChooserParams;
import nianio.complib.filechooser.FileChooserResult;
import nianioTest.nianio.types.SelectFileCmdInvokerIntf;

public class SelectFileCmdInvokerImpl implements SelectFileCmdInvokerIntf {
	private final FileChooserKind kind;
	private final Extensions extensions;
	private final String description;

	public SelectFileCmdInvokerImpl(FileChooserKind kind, Extensions ext,
			String description) {
		this.kind = kind;
		this.extensions = ext;
		this.description = description;
	}

	public SelectFileState setFileName(SelectFileState state, String value,
			MMIntf deliverer) {
		return state.setFileName(value);
	}

	public SelectFileState selectFromFileChooser(SelectFileState state,
			MMIntf deliverer) {
		if (state.tryGetFileChooserState() != null)
			return state;
		FileChooserParams fp = FileChooserParams.create(kind, null, extensions,
				description);
		state = state.setFileChooserState(fp);
		deliverer.openFileChooser(fp);
		return state;
	}

	public SelectFileState fileSelected(SelectFileState state,
			FileChooserResult value, MMIntf deliverer) {
		String path = value.tryGetPath();
		if (path != null)
			state = state.setFileName(path);
		return state.setFileChooserState(null);
	}

}
