package nianioTest.nianio.types;

import nianio.AppLogicCmd;
import nianio.AppState;
import nianio.AppLogicExtCmd.MMIntf;
import ocean.common.Err;

public class AppLogicNianio {

	public static AppLogicNianioIntf create(
			final AppLogicCommandInvokerIntf invoker) {
		return new AppLogicNianioIntf() {
			public AppState invoke(AppState state, AppLogicCmd cmd,
					MMIntf deliverer) {
				if (cmd.isRun()) {
					return invoker.run(state, deliverer);
				} else if (cmd.isClose()) {
					return invoker.close(state, deliverer);
				} else if (cmd.isSetPdfOutput()) {
					return invoker.setPdfOutput(state, deliverer);
				} else if (cmd.isSetHtmlOutput()) {
					return invoker.setHtmlOutput(state, deliverer);
				} else if (cmd.isSetXlsOutput()) {
					return invoker.setXlsOutput(state, deliverer);
				} else if (cmd.isGenerateRequest()) {
					return invoker.generateRequest(state, deliverer);
				} else if (cmd.isReportGenerated()) {
					return invoker.reportGenerated(state,
							cmd.asReportGenerated(), deliverer);
				} else if (cmd.isReportFileCmd()) {
					return invoker.reportFileCmd(state, cmd.asReportFileCmd(),
							deliverer);
				} else if (cmd.isXmlFileCmd()) {
					return invoker.xmlFileCmd(state, cmd.asXmlFileCmd(),
							deliverer);
				} else if (cmd.isXsdFileCmd()) {
					return invoker.xsdFileCmd(state, cmd.asXsdFileCmd(),
							deliverer);
				} else if (cmd.isOutputFileCmd()) {
					return invoker.outputFileCmd(state, cmd.asOutputFileCmd(),
							deliverer);
				} else if (cmd.isMessageDialogClosed()) {
					return invoker.messageDialogClosed(state, deliverer,
							cmd.asMessageDialogClosed());
				} else
					throw Err.errM(cmd);
			}

		};
	}

}
