package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class AppCommand = variant {
 *	    run 
 *	 |  event of Event  
 * }</pre>
 */ 
public class AppCommand implements ImmObject {
	private static final int TYPE_HASH = -218602998;
	private int hash = 0;

	private static final AppCommand CONST_RUN = new AppCommand(0);
	private final int variant;
	private final Object value;  

	private AppCommand(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private AppCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static AppCommand createRun() {
		return CONST_RUN;
	}

	public static AppCommand createEvent(Event value) {
		return new AppCommand(1, value);
	}



	/** @return true, when this is run */
	public boolean isRun() {
		return variant == 0;
	}


	/** @return true, when this is event */
	public boolean isEvent() {
		return variant == 1;
	}

	/** @return variant value, when this is event; throws Exception otherwise */
	public Event asEvent() {
		SchemaException.ensure(isEvent());
		return (Event)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isRun()) {
			;
		} else if (isEvent()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isRun()) {
			;
		} else if (isEvent()) {
			asEvent();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isRun())
			return "run";		
		if (isEvent())
			return "event" + "(" + asEvent() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(AppCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof AppCommand) 
			&& this.eq((AppCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}