package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.complib.messagedialog.MessageDialogParams;


/** 
 * <pre>Autogenerated class Entry = {
 *		  key  : String
 *		  value  : MessageDialogParams
 * }</pre>
 */ 

public class Entry implements ImmObject {
	private static final int TYPE_HASH = 67115090;
	private int hash = 0;

	final private String key;
	final private MessageDialogParams value;
			
	private Entry(
		 String key
		, MessageDialogParams value
	) {
		this.key = key;
		this.value = value;
	}
	

	/** Creates a struct record with given values
	 * @param key != null (mandatory)
	 * @param value != null (mandatory)
	 */
	public static Entry create(
		 String key
		, MessageDialogParams value
	) {
		SchemaException.ensure(key != null);
		SchemaException.ensure(value != null);

		return new Entry(
			 key
			, value
		);		
	}


	/* getters */
	
	/** field key, should never return null */
	public String getKey() {
		return this.key;
	}
	/** field value, should never return null */
	public MessageDialogParams getValue() {
		return this.value;
	}

	/* setters */
	
	/** create struct with field key modified, 
	 * (exception when arg==null) */
	public Entry setKey(String key) {	 
		SchemaException.ensure(key != null);
		return new Entry(
			  key 		
			, this.value 		
		);		
	}
	/** create struct with field value modified, 
	 * (exception when arg==null) */
	public Entry setValue(MessageDialogParams value) {	 
		SchemaException.ensure(value != null);
		return new Entry(
			  this.key 		
			, value 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof Entry) 
			&& this.eq((Entry)obj);
	}
	
	public boolean eq(Entry obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqKey(this, obj)
			&& eqValue(this, obj)
			;
	}

	private static boolean eqKey(Entry o1, Entry o2) {
		String f1 = o1.getKey();
		String f2 = o2.getKey();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqValue(Entry o1, Entry o2) {
		MessageDialogParams f1 = o1.getValue();
		MessageDialogParams f2 = o2.getValue();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("key" + "=");
		out.append(getKey());
		out.append(", ");
		out.append("value" + "=");
		out.append(getValue());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.key.hashCode() + 1227380495;
			h ^= this.value.hashCode() + -1593319903;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}