package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class Status = variant {
 *	    generatingReport of int  
 *	 |  ready 
 * }</pre>
 */ 
public class Status implements ImmObject {
	private static final int TYPE_HASH = -1808614382;
	private int hash = 0;

	private static final Status CONST_READY = new Status(1);
	private final int variant;
	private final Object value;  

	private Status(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private Status(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static Status createGeneratingReport(int value) {
		return new Status(0, new Integer(value));
	}

	public static Status createReady() {
		return CONST_READY;
	}



	/** @return true, when this is generatingReport */
	public boolean isGeneratingReport() {
		return variant == 0;
	}

	/** @return variant value, when this is generatingReport; throws Exception otherwise */
	public int asGeneratingReport() {
		SchemaException.ensure(isGeneratingReport());
		return ((Integer)value).intValue();
	}

	/** @return true, when this is ready */
	public boolean isReady() {
		return variant == 1;
	}




	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isGeneratingReport()) {
			;
		} else if (isReady()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isGeneratingReport()) {
			asGeneratingReport();
		} else if (isReady()) {
			;
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isGeneratingReport())
			return "generatingReport" + "(" + asGeneratingReport() + ")";
		if (isReady())
			return "ready";		
		throw SchemaException.err();
	}
	
	public boolean eq(Status obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof Status) 
			&& this.eq((Status)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}