package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.UserDialogId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class UserDialogIdCommand = {
 *		  id  : UserDialogId
 *		  cmd  : UserDialogCommand
 * }</pre>
 */ 

public class UserDialogIdCommand implements ImmObject {
	private static final int TYPE_HASH = 1308179933;
	private int hash = 0;

	final private UserDialogId id;
	final private UserDialogCommand cmd;
			
	private UserDialogIdCommand(
		 UserDialogId id
		, UserDialogCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static UserDialogIdCommand create(
		 UserDialogId id
		, UserDialogCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new UserDialogIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public UserDialogId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public UserDialogCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public UserDialogIdCommand setId(UserDialogId id) {	 
		SchemaException.ensure(id != null);
		return new UserDialogIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public UserDialogIdCommand setCmd(UserDialogCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new UserDialogIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof UserDialogIdCommand) 
			&& this.eq((UserDialogIdCommand)obj);
	}
	
	public boolean eq(UserDialogIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(UserDialogIdCommand o1, UserDialogIdCommand o2) {
		UserDialogId f1 = o1.getId();
		UserDialogId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(UserDialogIdCommand o1, UserDialogIdCommand o2) {
		UserDialogCommand f1 = o1.getCmd();
		UserDialogCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}