package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.ButtonId;


/** 
 * <pre>Autogenerated class ButtonIdCommand = {
 *		  id  : ButtonId
 *		  cmd  : ButtonCommand
 * }</pre>
 */ 

public class ButtonIdCommand implements ImmObject {
	private static final int TYPE_HASH = -220451202;
	private int hash = 0;

	final private ButtonId id;
	final private ButtonCommand cmd;
			
	private ButtonIdCommand(
		 ButtonId id
		, ButtonCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static ButtonIdCommand create(
		 ButtonId id
		, ButtonCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new ButtonIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public ButtonId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public ButtonCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public ButtonIdCommand setId(ButtonId id) {	 
		SchemaException.ensure(id != null);
		return new ButtonIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public ButtonIdCommand setCmd(ButtonCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new ButtonIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ButtonIdCommand) 
			&& this.eq((ButtonIdCommand)obj);
	}
	
	public boolean eq(ButtonIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(ButtonIdCommand o1, ButtonIdCommand o2) {
		ButtonId f1 = o1.getId();
		ButtonId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(ButtonIdCommand o1, ButtonIdCommand o2) {
		ButtonCommand f1 = o1.getCmd();
		ButtonCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}