package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.ButtonId;


/** 
 * <pre>Autogenerated class ButtonIdEvent = {
 *		  id  : ButtonId
 *		  cmd  : ButtonEvent
 * }</pre>
 */ 

public class ButtonIdEvent implements ImmObject {
	private static final int TYPE_HASH = -610471283;
	private int hash = 0;

	final private ButtonId id;
	final private ButtonEvent cmd;
			
	private ButtonIdEvent(
		 ButtonId id
		, ButtonEvent cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static ButtonIdEvent create(
		 ButtonId id
		, ButtonEvent cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new ButtonIdEvent(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public ButtonId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public ButtonEvent getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public ButtonIdEvent setId(ButtonId id) {	 
		SchemaException.ensure(id != null);
		return new ButtonIdEvent(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public ButtonIdEvent setCmd(ButtonEvent cmd) {	 
		SchemaException.ensure(cmd != null);
		return new ButtonIdEvent(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ButtonIdEvent) 
			&& this.eq((ButtonIdEvent)obj);
	}
	
	public boolean eq(ButtonIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(ButtonIdEvent o1, ButtonIdEvent o2) {
		ButtonId f1 = o1.getId();
		ButtonId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(ButtonIdEvent o1, ButtonIdEvent o2) {
		ButtonEvent f1 = o1.getCmd();
		ButtonEvent f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}