package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of RadioButtonState
 * Autogenerated class Buttons
 * </pre>
 */ 
public class Buttons implements ImmObject {
	public static final Buttons EMPTY = new Buttons();

	private final ObjectArray arr;
	
	private Buttons(ObjectArray arr) {
		this.arr = arr;
	}
	
	public Buttons() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(Buttons obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof Buttons) 
				&& eq((Buttons)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public Buttons add(RadioButtonState elem) {
		SchemaException.ensure(elem != null);
		return new Buttons(arr.add(elem));
	}

	public Buttons put(int i, RadioButtonState elem) {
		SchemaException.ensure(elem != null);
		return new Buttons(arr.put(i, elem));
	}

	public Buttons insert(int pos, RadioButtonState elem) {
		SchemaException.ensure(elem != null);
		return new Buttons(arr.insert(pos, elem));
	}

	public Buttons remove(int index) {
		return new Buttons(arr.remove(index));
	}

	public Buttons move(int oldpos, int newpos) {
		return new Buttons(arr.move(oldpos, newpos));
	}

	public Buttons concat(Buttons obj) {
		Buttons res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public RadioButtonState get(int ix) {
		RadioButtonState elem = (RadioButtonState) (arr.get(ix));
		return elem;
	}
	
	public int find(RadioButtonState elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
