package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.LabelId;


/** 
 * <pre>Autogenerated class LabelIdCommand = {
 *		  id  : LabelId
 *		  cmd  : LabelCommand
 * }</pre>
 */ 

public class LabelIdCommand implements ImmObject {
	private static final int TYPE_HASH = -1542683332;
	private int hash = 0;

	final private LabelId id;
	final private LabelCommand cmd;
			
	private LabelIdCommand(
		 LabelId id
		, LabelCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static LabelIdCommand create(
		 LabelId id
		, LabelCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new LabelIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public LabelId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public LabelCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public LabelIdCommand setId(LabelId id) {	 
		SchemaException.ensure(id != null);
		return new LabelIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public LabelIdCommand setCmd(LabelCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new LabelIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof LabelIdCommand) 
			&& this.eq((LabelIdCommand)obj);
	}
	
	public boolean eq(LabelIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(LabelIdCommand o1, LabelIdCommand o2) {
		LabelId f1 = o1.getId();
		LabelId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(LabelIdCommand o1, LabelIdCommand o2) {
		LabelCommand f1 = o1.getCmd();
		LabelCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}