package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.LabelId;


/** 
 * <pre>Autogenerated class LabelState = {
 *		  id  : LabelId
 *		  text  : String
 * }</pre>
 */ 

public class LabelState implements ImmObject {
	private static final int TYPE_HASH = 332884509;
	private int hash = 0;

	final private LabelId id;
	final private String text;
			
	private LabelState(
		 LabelId id
		, String text
	) {
		this.id = id;
		this.text = text;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param text != null (mandatory)
	 */
	public static LabelState create(
		 LabelId id
		, String text
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(text != null);

		return new LabelState(
			 id
			, text
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public LabelId getId() {
		return this.id;
	}
	/** field text, should never return null */
	public String getText() {
		return this.text;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public LabelState setId(LabelId id) {	 
		SchemaException.ensure(id != null);
		return new LabelState(
			  id 		
			, this.text 		
		);		
	}
	/** create struct with field text modified, 
	 * (exception when arg==null) */
	public LabelState setText(String text) {	 
		SchemaException.ensure(text != null);
		return new LabelState(
			  this.id 		
			, text 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof LabelState) 
			&& this.eq((LabelState)obj);
	}
	
	public boolean eq(LabelState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqText(this, obj)
			;
	}

	private static boolean eqId(LabelState o1, LabelState o2) {
		LabelId f1 = o1.getId();
		LabelId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqText(LabelState o1, LabelState o2) {
		String f1 = o1.getText();
		String f2 = o2.getText();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("text" + "=");
		out.append(getText());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.text.hashCode() + -605642115;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}