package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonId;
import nianio.ids.RadioButtonGroupId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class RadioButtonGroupState = {
 *		  id  : RadioButtonGroupId
 *		  selectedId  : RadioButtonId
 *		  label  : String
 *		  buttons  : Buttons
 * }</pre>
 */ 

public class RadioButtonGroupState implements ImmObject {
	private static final int TYPE_HASH = 1963103263;
	private int hash = 0;

	final private RadioButtonGroupId id;
	final private RadioButtonId selectedId;
	final private String label;
	final private Buttons buttons;
			
	private RadioButtonGroupState(
		 RadioButtonGroupId id
		, RadioButtonId selectedId
		, String label
		, Buttons buttons
	) {
		this.id = id;
		this.selectedId = selectedId;
		this.label = label;
		this.buttons = buttons;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param selectedId != null (mandatory)
	 * @param label != null (mandatory)
	 * @param buttons != null (mandatory)
	 */
	public static RadioButtonGroupState create(
		 RadioButtonGroupId id
		, RadioButtonId selectedId
		, String label
		, Buttons buttons
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(selectedId != null);
		SchemaException.ensure(label != null);
		SchemaException.ensure(buttons != null);

		return new RadioButtonGroupState(
			 id
			, selectedId
			, label
			, buttons
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public RadioButtonGroupId getId() {
		return this.id;
	}
	/** field selectedId, should never return null */
	public RadioButtonId getSelectedId() {
		return this.selectedId;
	}
	/** field label, should never return null */
	public String getLabel() {
		return this.label;
	}
	/** field buttons, should never return null */
	public Buttons getButtons() {
		return this.buttons;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupState setId(RadioButtonGroupId id) {	 
		SchemaException.ensure(id != null);
		return new RadioButtonGroupState(
			  id 		
			, this.selectedId 		
			, this.label 		
			, this.buttons 		
		);		
	}
	/** create struct with field selectedId modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupState setSelectedId(RadioButtonId selectedId) {	 
		SchemaException.ensure(selectedId != null);
		return new RadioButtonGroupState(
			  this.id 		
			, selectedId 		
			, this.label 		
			, this.buttons 		
		);		
	}
	/** create struct with field label modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupState setLabel(String label) {	 
		SchemaException.ensure(label != null);
		return new RadioButtonGroupState(
			  this.id 		
			, this.selectedId 		
			, label 		
			, this.buttons 		
		);		
	}
	/** create struct with field buttons modified, 
	 * (exception when arg==null) */
	public RadioButtonGroupState setButtons(Buttons buttons) {	 
		SchemaException.ensure(buttons != null);
		return new RadioButtonGroupState(
			  this.id 		
			, this.selectedId 		
			, this.label 		
			, buttons 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonGroupState) 
			&& this.eq((RadioButtonGroupState)obj);
	}
	
	public boolean eq(RadioButtonGroupState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqSelectedId(this, obj)
			&& eqLabel(this, obj)
			&& eqButtons(this, obj)
			;
	}

	private static boolean eqId(RadioButtonGroupState o1, RadioButtonGroupState o2) {
		RadioButtonGroupId f1 = o1.getId();
		RadioButtonGroupId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqSelectedId(RadioButtonGroupState o1, RadioButtonGroupState o2) {
		RadioButtonId f1 = o1.getSelectedId();
		RadioButtonId f2 = o2.getSelectedId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqLabel(RadioButtonGroupState o1, RadioButtonGroupState o2) {
		String f1 = o1.getLabel();
		String f2 = o2.getLabel();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqButtons(RadioButtonGroupState o1, RadioButtonGroupState o2) {
		Buttons f1 = o1.getButtons();
		Buttons f2 = o2.getButtons();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("selectedId" + "=");
		out.append(getSelectedId());
		out.append(", ");
		out.append("label" + "=");
		out.append(getLabel());
		out.append(", ");
		out.append("buttons" + "=");
		out.append(getButtons());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.selectedId.hashCode() + 545055334;
			h ^= this.label.hashCode() + -1602565212;
			h ^= this.buttons.hashCode() + 2132647985;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}