package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.TextBoxId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class TextBoxIdCommand = {
 *		  id  : TextBoxId
 *		  cmd  : TextBoxCommand
 * }</pre>
 */ 

public class TextBoxIdCommand implements ImmObject {
	private static final int TYPE_HASH = -276955630;
	private int hash = 0;

	final private TextBoxId id;
	final private TextBoxCommand cmd;
			
	private TextBoxIdCommand(
		 TextBoxId id
		, TextBoxCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static TextBoxIdCommand create(
		 TextBoxId id
		, TextBoxCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new TextBoxIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public TextBoxId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public TextBoxCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public TextBoxIdCommand setId(TextBoxId id) {	 
		SchemaException.ensure(id != null);
		return new TextBoxIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public TextBoxIdCommand setCmd(TextBoxCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new TextBoxIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof TextBoxIdCommand) 
			&& this.eq((TextBoxIdCommand)obj);
	}
	
	public boolean eq(TextBoxIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(TextBoxIdCommand o1, TextBoxIdCommand o2) {
		TextBoxId f1 = o1.getId();
		TextBoxId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(TextBoxIdCommand o1, TextBoxIdCommand o2) {
		TextBoxCommand f1 = o1.getCmd();
		TextBoxCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}