package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.FileChooserId;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class FileChooserCommand = variant {
 *	    createAndShow of FileChooserIdParams  
 * }</pre>
 */ 
public class FileChooserCommand implements ImmObject {
	private static final int TYPE_HASH = 1950553676;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private FileChooserCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static FileChooserCommand createCreateAndShow(FileChooserIdParams value) {
		return new FileChooserCommand(0, value);
	}


	public static FileChooserCommand mkCreateAndShow(
			FileChooserId id
			, WindowId parentId
			, FileChooserParams params
	) {
		return createCreateAndShow( FileChooserIdParams.create(
							id
							, parentId
							, params
							 ));
	}
	

	/** @return true, when this is createAndShow */
	public boolean isCreateAndShow() {
		return variant == 0;
	}

	/** @return variant value, when this is createAndShow; throws Exception otherwise */
	public FileChooserIdParams asCreateAndShow() {
		SchemaException.ensure(isCreateAndShow());
		return (FileChooserIdParams)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isCreateAndShow()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isCreateAndShow()) {
			asCreateAndShow();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isCreateAndShow())
			return "createAndShow" + "(" + asCreateAndShow() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(FileChooserCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof FileChooserCommand) 
			&& this.eq((FileChooserCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for FileChooserCommand
	 */
	public static interface MM {
		public void invoke(FileChooserCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for FileChooserCommand
	 */
	public static interface MMIntf {
		public void createAndShow(
				 FileChooserId id
				, WindowId parentId
				, FileChooserParams params
		);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for FileChooserCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(FileChooserCommand cmd) {
				 if (cmd.isCreateAndShow()) {
					FileChooserIdParams val = cmd.asCreateAndShow();
					mm.createAndShow(
							 val.getId()
							, val.getParentId()
							, val.getParams()
					);
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void createAndShow(
							 FileChooserId id
							, WindowId parentId
							, FileChooserParams params
			) {
				mm.invoke( FileChooserCommand.createCreateAndShow(
								FileChooserIdParams.create( 
									id, parentId, params)));		
			}
		
		}
	}
}