package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class FileChooserParams = {
 *		  kind  : FileChooserKind
 *		? path  : String
 *		  extensions  : Extensions
 *		  description  : String
 * }</pre>
 */ 

public class FileChooserParams implements ImmObject {
	private static final int TYPE_HASH = 1392139877;
	private int hash = 0;

	final private FileChooserKind kind;
	final private String path;
	final private Extensions extensions;
	final private String description;
			
	private FileChooserParams(
		 FileChooserKind kind
		, String path
		, Extensions extensions
		, String description
	) {
		this.kind = kind;
		this.path = path;
		this.extensions = extensions;
		this.description = description;
	}
	

	/** Creates a struct record with given values
	 * @param kind != null (mandatory)
	 * @param pathOrNull may be null (optional)
	 * @param extensions != null (mandatory)
	 * @param description != null (mandatory)
	 */
	public static FileChooserParams create(
		 FileChooserKind kind
		, String pathOrNull
		, Extensions extensions
		, String description
	) {
		SchemaException.ensure(kind != null);
		SchemaException.ensure(extensions != null);
		SchemaException.ensure(description != null);

		return new FileChooserParams(
			 kind
			, pathOrNull
			, extensions
			, description
		);		
	}


	/* getters */
	
	/** field kind, should never return null */
	public FileChooserKind getKind() {
		return this.kind;
	}
	/** field path, may return null */
	public String tryGetPath() {
		return this.path;
	}
	/** field extensions, should never return null */
	public Extensions getExtensions() {
		return this.extensions;
	}
	/** field description, should never return null */
	public String getDescription() {
		return this.description;
	}

	/* setters */
	
	/** create struct with field kind modified, 
	 * (exception when arg==null) */
	public FileChooserParams setKind(FileChooserKind kind) {	 
		SchemaException.ensure(kind != null);
		return new FileChooserParams(
			  kind 		
			, this.path 		
			, this.extensions 		
			, this.description 		
		);		
	}
	/** create struct with field path modified
	 * (or removed, when arg==null) */
	public FileChooserParams setPath(String pathOrNull) {	 
		return new FileChooserParams(
			  this.kind 		
			, pathOrNull 		
			, this.extensions 		
			, this.description 		
		);		
	}
	/** create struct with field extensions modified, 
	 * (exception when arg==null) */
	public FileChooserParams setExtensions(Extensions extensions) {	 
		SchemaException.ensure(extensions != null);
		return new FileChooserParams(
			  this.kind 		
			, this.path 		
			, extensions 		
			, this.description 		
		);		
	}
	/** create struct with field description modified, 
	 * (exception when arg==null) */
	public FileChooserParams setDescription(String description) {	 
		SchemaException.ensure(description != null);
		return new FileChooserParams(
			  this.kind 		
			, this.path 		
			, this.extensions 		
			, description 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof FileChooserParams) 
			&& this.eq((FileChooserParams)obj);
	}
	
	public boolean eq(FileChooserParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqKind(this, obj)
			&& eqPath(this, obj)
			&& eqExtensions(this, obj)
			&& eqDescription(this, obj)
			;
	}

	private static boolean eqKind(FileChooserParams o1, FileChooserParams o2) {
		FileChooserKind f1 = o1.getKind();
		FileChooserKind f2 = o2.getKind();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqPath(FileChooserParams o1, FileChooserParams o2) {
		String f1 = o1.tryGetPath();
		String f2 = o2.tryGetPath();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqExtensions(FileChooserParams o1, FileChooserParams o2) {
		Extensions f1 = o1.getExtensions();
		Extensions f2 = o2.getExtensions();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqDescription(FileChooserParams o1, FileChooserParams o2) {
		String f1 = o1.getDescription();
		String f2 = o2.getDescription();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("kind" + "=");
		out.append(getKind());
		out.append(", ");
		out.append("path" + "=");
		out.append(tryGetPath());
		out.append(", ");
		out.append("extensions" + "=");
		out.append(getExtensions());
		out.append(", ");
		out.append("description" + "=");
		out.append(getDescription());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.kind.hashCode() + -605906716;
			h ^= this.path == null ? -605765259 : this.path.hashCode() + -605765259;
			h ^= this.extensions.hashCode() + 391089508;
			h ^= this.description.hashCode() + 2066779308;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}