package nianio.complib.messagedialog;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;
import nianio.ids.MessageDialogId;


/** 
 * <pre>Autogenerated class MessageDialogIdParams = {
 *		  id  : MessageDialogId
 *		  parentId  : WindowId
 *		  params  : MessageDialogParams
 * }</pre>
 */ 

public class MessageDialogIdParams implements ImmObject {
	private static final int TYPE_HASH = -1684795472;
	private int hash = 0;

	final private MessageDialogId id;
	final private WindowId parentId;
	final private MessageDialogParams params;
			
	private MessageDialogIdParams(
		 MessageDialogId id
		, WindowId parentId
		, MessageDialogParams params
	) {
		this.id = id;
		this.parentId = parentId;
		this.params = params;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param parentId != null (mandatory)
	 * @param params != null (mandatory)
	 */
	public static MessageDialogIdParams create(
		 MessageDialogId id
		, WindowId parentId
		, MessageDialogParams params
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(parentId != null);
		SchemaException.ensure(params != null);

		return new MessageDialogIdParams(
			 id
			, parentId
			, params
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public MessageDialogId getId() {
		return this.id;
	}
	/** field parentId, should never return null */
	public WindowId getParentId() {
		return this.parentId;
	}
	/** field params, should never return null */
	public MessageDialogParams getParams() {
		return this.params;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public MessageDialogIdParams setId(MessageDialogId id) {	 
		SchemaException.ensure(id != null);
		return new MessageDialogIdParams(
			  id 		
			, this.parentId 		
			, this.params 		
		);		
	}
	/** create struct with field parentId modified, 
	 * (exception when arg==null) */
	public MessageDialogIdParams setParentId(WindowId parentId) {	 
		SchemaException.ensure(parentId != null);
		return new MessageDialogIdParams(
			  this.id 		
			, parentId 		
			, this.params 		
		);		
	}
	/** create struct with field params modified, 
	 * (exception when arg==null) */
	public MessageDialogIdParams setParams(MessageDialogParams params) {	 
		SchemaException.ensure(params != null);
		return new MessageDialogIdParams(
			  this.id 		
			, this.parentId 		
			, params 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof MessageDialogIdParams) 
			&& this.eq((MessageDialogIdParams)obj);
	}
	
	public boolean eq(MessageDialogIdParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqParentId(this, obj)
			&& eqParams(this, obj)
			;
	}

	private static boolean eqId(MessageDialogIdParams o1, MessageDialogIdParams o2) {
		MessageDialogId f1 = o1.getId();
		MessageDialogId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqParentId(MessageDialogIdParams o1, MessageDialogIdParams o2) {
		WindowId f1 = o1.getParentId();
		WindowId f2 = o2.getParentId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqParams(MessageDialogIdParams o1, MessageDialogIdParams o2) {
		MessageDialogParams f1 = o1.getParams();
		MessageDialogParams f2 = o2.getParams();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("parentId" + "=");
		out.append(getParentId());
		out.append(", ");
		out.append("params" + "=");
		out.append(getParams());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.parentId.hashCode() + -324221771;
			h ^= this.params.hashCode() + 1975075542;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}