package nianio.genrap;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class GenrapPluginCommand = variant {
 *	    generateReport of ReportParams  
 * }</pre>
 */ 
public class GenrapPluginCommand implements ImmObject {
	private static final int TYPE_HASH = -1114356441;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private GenrapPluginCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static GenrapPluginCommand createGenerateReport(ReportParams value) {
		return new GenrapPluginCommand(0, value);
	}


	public static GenrapPluginCommand mkGenerateReport(
			String xmlFileName
			, String xsdFileName
			, String reportFileName
			, String outputFileName
			, OutputKind outputKind
	) {
		return createGenerateReport( ReportParams.create(
							xmlFileName
							, xsdFileName
							, reportFileName
							, outputFileName
							, outputKind
							 ));
	}
	

	/** @return true, when this is generateReport */
	public boolean isGenerateReport() {
		return variant == 0;
	}

	/** @return variant value, when this is generateReport; throws Exception otherwise */
	public ReportParams asGenerateReport() {
		SchemaException.ensure(isGenerateReport());
		return (ReportParams)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isGenerateReport()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isGenerateReport()) {
			asGenerateReport();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isGenerateReport())
			return "generateReport" + "(" + asGenerateReport() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(GenrapPluginCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof GenrapPluginCommand) 
			&& this.eq((GenrapPluginCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}