package nianio.genrap;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class OutputKind =
 * variant (enumeration) {
 *	    html 
 *	 |  pdf 
 *	 |  xls 
 * }
 */ 
public class OutputKind implements ImmObject {
	private static final int TYPE_HASH = 719338581;


	private static final OutputKind CONST_HTML = new OutputKind(0);
	private static final OutputKind CONST_PDF = new OutputKind(1);
	private static final OutputKind CONST_XLS = new OutputKind(2);

	private final int variant;

	private OutputKind(int variant) {
		this.variant = variant;
	}


	public static OutputKind createHtml() {
		return CONST_HTML;
	}
	
	public static OutputKind createPdf() {
		return CONST_PDF;
	}
	
	public static OutputKind createXls() {
		return CONST_XLS;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isHtml()) {
			;
		} else if (isPdf()) {
			;
		} else if (isXls()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is html */
	public boolean isHtml() {
		return variant == 0;
	}

	/** @return true, when this is pdf */
	public boolean isPdf() {
		return variant == 1;
	}

	/** @return true, when this is xls */
	public boolean isXls() {
		return variant == 2;
	}




	public String toString() {
		if (isHtml())
			return "html";
		if (isPdf())
			return "pdf";
		if (isXls())
			return "xls";
		throw SchemaException.err();
	}
	
	public boolean eq(OutputKind obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof OutputKind) 
			&& this.eq((OutputKind)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		
}