package nianio.genrap;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class ReportParams = {
 *		  xmlFileName  : String
 *		  xsdFileName  : String
 *		  reportFileName  : String
 *		  outputFileName  : String
 *		  outputKind  : OutputKind
 * }</pre>
 */ 

public class ReportParams implements ImmObject {
	private static final int TYPE_HASH = 664262650;
	private int hash = 0;

	final private String xmlFileName;
	final private String xsdFileName;
	final private String reportFileName;
	final private String outputFileName;
	final private OutputKind outputKind;
			
	private ReportParams(
		 String xmlFileName
		, String xsdFileName
		, String reportFileName
		, String outputFileName
		, OutputKind outputKind
	) {
		this.xmlFileName = xmlFileName;
		this.xsdFileName = xsdFileName;
		this.reportFileName = reportFileName;
		this.outputFileName = outputFileName;
		this.outputKind = outputKind;
	}
	

	/** Creates a struct record with given values
	 * @param xmlFileName != null (mandatory)
	 * @param xsdFileName != null (mandatory)
	 * @param reportFileName != null (mandatory)
	 * @param outputFileName != null (mandatory)
	 * @param outputKind != null (mandatory)
	 */
	public static ReportParams create(
		 String xmlFileName
		, String xsdFileName
		, String reportFileName
		, String outputFileName
		, OutputKind outputKind
	) {
		SchemaException.ensure(xmlFileName != null);
		SchemaException.ensure(xsdFileName != null);
		SchemaException.ensure(reportFileName != null);
		SchemaException.ensure(outputFileName != null);
		SchemaException.ensure(outputKind != null);

		return new ReportParams(
			 xmlFileName
			, xsdFileName
			, reportFileName
			, outputFileName
			, outputKind
		);		
	}


	/* getters */
	
	/** field xmlFileName, should never return null */
	public String getXmlFileName() {
		return this.xmlFileName;
	}
	/** field xsdFileName, should never return null */
	public String getXsdFileName() {
		return this.xsdFileName;
	}
	/** field reportFileName, should never return null */
	public String getReportFileName() {
		return this.reportFileName;
	}
	/** field outputFileName, should never return null */
	public String getOutputFileName() {
		return this.outputFileName;
	}
	/** field outputKind, should never return null */
	public OutputKind getOutputKind() {
		return this.outputKind;
	}

	/* setters */
	
	/** create struct with field xmlFileName modified, 
	 * (exception when arg==null) */
	public ReportParams setXmlFileName(String xmlFileName) {	 
		SchemaException.ensure(xmlFileName != null);
		return new ReportParams(
			  xmlFileName 		
			, this.xsdFileName 		
			, this.reportFileName 		
			, this.outputFileName 		
			, this.outputKind 		
		);		
	}
	/** create struct with field xsdFileName modified, 
	 * (exception when arg==null) */
	public ReportParams setXsdFileName(String xsdFileName) {	 
		SchemaException.ensure(xsdFileName != null);
		return new ReportParams(
			  this.xmlFileName 		
			, xsdFileName 		
			, this.reportFileName 		
			, this.outputFileName 		
			, this.outputKind 		
		);		
	}
	/** create struct with field reportFileName modified, 
	 * (exception when arg==null) */
	public ReportParams setReportFileName(String reportFileName) {	 
		SchemaException.ensure(reportFileName != null);
		return new ReportParams(
			  this.xmlFileName 		
			, this.xsdFileName 		
			, reportFileName 		
			, this.outputFileName 		
			, this.outputKind 		
		);		
	}
	/** create struct with field outputFileName modified, 
	 * (exception when arg==null) */
	public ReportParams setOutputFileName(String outputFileName) {	 
		SchemaException.ensure(outputFileName != null);
		return new ReportParams(
			  this.xmlFileName 		
			, this.xsdFileName 		
			, this.reportFileName 		
			, outputFileName 		
			, this.outputKind 		
		);		
	}
	/** create struct with field outputKind modified, 
	 * (exception when arg==null) */
	public ReportParams setOutputKind(OutputKind outputKind) {	 
		SchemaException.ensure(outputKind != null);
		return new ReportParams(
			  this.xmlFileName 		
			, this.xsdFileName 		
			, this.reportFileName 		
			, this.outputFileName 		
			, outputKind 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ReportParams) 
			&& this.eq((ReportParams)obj);
	}
	
	public boolean eq(ReportParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqXmlFileName(this, obj)
			&& eqXsdFileName(this, obj)
			&& eqReportFileName(this, obj)
			&& eqOutputFileName(this, obj)
			&& eqOutputKind(this, obj)
			;
	}

	private static boolean eqXmlFileName(ReportParams o1, ReportParams o2) {
		String f1 = o1.getXmlFileName();
		String f2 = o2.getXmlFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqXsdFileName(ReportParams o1, ReportParams o2) {
		String f1 = o1.getXsdFileName();
		String f2 = o2.getXsdFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqReportFileName(ReportParams o1, ReportParams o2) {
		String f1 = o1.getReportFileName();
		String f2 = o2.getReportFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqOutputFileName(ReportParams o1, ReportParams o2) {
		String f1 = o1.getOutputFileName();
		String f2 = o2.getOutputFileName();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqOutputKind(ReportParams o1, ReportParams o2) {
		OutputKind f1 = o1.getOutputKind();
		OutputKind f2 = o2.getOutputKind();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("xmlFileName" + "=");
		out.append(getXmlFileName());
		out.append(", ");
		out.append("xsdFileName" + "=");
		out.append(getXsdFileName());
		out.append(", ");
		out.append("reportFileName" + "=");
		out.append(getReportFileName());
		out.append(", ");
		out.append("outputFileName" + "=");
		out.append(getOutputFileName());
		out.append(", ");
		out.append("outputKind" + "=");
		out.append(getOutputKind());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.xmlFileName.hashCode() + 357760014;
			h ^= this.xsdFileName.hashCode() + 753412800;
			h ^= this.reportFileName.hashCode() + 119932107;
			h ^= this.outputFileName.hashCode() + -633033832;
			h ^= this.outputKind.hashCode() + 926384517;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}