#!/usr/bin/perl

use Imm;

sub isSubstring {
	my ($string, @subs) = @_;
	for my $sub (@subs) {
		if ($string =~ /^$sub/) {
			return 1;
		}
	}
	return 0;
}

sub output {
	my ($stream, $string, %imm) = @_;
	$type = Imm::value('type', %imm);
	if ($type eq 'terminate') {
		$imm{'type'}='error';
		Imm::print($OUT, %imm);
	} elsif ($type eq 'error') {
		print $OUT $string;
	} elsif ($type eq 'warning') {
		print $OUT $string;
	} else {
		die "unknown type: ", $type;
	}
}

#"USAGE: $0 [ignore_paths]\n"
my @ignorePaths = $ARGV[0] =~ /([^:]+)/g;
shift;

open $OUT, ">-";
while(my $line = <>) {
	%msg = Imm::get($line);
	if (defined @ignorePaths && isSubstring(Imm::value('path', %msg), @ignorePaths)) {
		if (Imm::value('type', %msg) eq 'terminate') {
			output($OUT, $line, %msg);
		}
	} else {
		output($OUT, $line, %msg);
	}
}
close $OUT;